Description

The atom feed from a Project does not truncate the subjects, but using the link for All Projects does it.

Even using redmine.org > Projects > View all issues > Atom, issue 33965 is truncated:

    <title>Redmine - Defect #33965 (New): REST API: Method Not Available see used Status list as p

er the tra...</title>

    <link rel="alternate" href="https://www.redmine.org/issues/33965"/>

Related issues:

Related to Redmine - Patch #1356: In Activity views, changesets titles can be... Closed 2008-06-02

Associated revisions

Revision 22685 - 2024-02-07 05:27 - Go MAEDA

Raise the maximum length of the title element in the Atom feed from 100 to 300 characters (#34025).

Patch by Go MAEDA (@maeda).

History

#1 - 2020-09-23 11:20 - Iker Mendiola

In fact, all atom feeds (not only for all project, but aslo por an individual project) are truncating issue subject to 100 chars.

Example in Redmine project:

    <title>Defect #33953 (Confirmed): Repository Tab will not showing if no repository is set as "Main repos..

.</title>

    <link rel="alternate" href="https://www.redmine.org/issues/33953"/>

 The probelm with "all projects" is that it adds the Project's name as prefix, so it is easier to truncate the value

Regards

#2 - 2020-09-23 17:16 - Go MAEDA

- Category set to Feeds

I agree that 100 chars is too short because the maximum length of Issue#title can be 255 chars. So, at least 255 chars of titles are handled without

truncation.

Atom feeds are added in r670 in 2007. At that time, Redmine already trimmed down the title to 100 chars.

#3 - 2020-09-28 16:51 - Iker Mendiola

Also take into account that generating the atom from All Projects > View all issues, it adds the project's name as prefix in the title field, so it will have

more characters....

#4 - 2020-12-20 13:08 - Go MAEDA

Go MAEDA wrote:

I agree that 100 chars is too short because the maximum length of Issue#title can be 255 chars. So, at least 255 chars of titles are handled

without truncation.

 The following patch changes the length limit of the title to 300. Since the maximum length of Issue#title is 255 chars, I think 300 is enough for most

cases.

2024-05-17 1/3

https://www.redmine.org/projects/redmine/repository/svn/revisions/670


diff --git a/app/views/common/feed.atom.builder b/app/views/common/feed.atom.builder

index 0fbe1063c..c151cf99a 100644

--- a/app/views/common/feed.atom.builder

+++ b/app/views/common/feed.atom.builder

@@ -4,7 +4,7 @@ protocol = Setting.protocol

 host = Setting.host_name

 xml.instruct!

 xml.feed "xmlns" => "http://www.w3.org/2005/Atom" do

-  xml.title truncate_single_line_raw(@title, 100)

+  xml.title truncate_single_line_raw(@title, 300)

   xml.link(

     "rel" => "self",

     "href" =>

@@ -37,9 +37,9 @@ xml.feed "xmlns" => "http://www.w3.org/2005/Atom" do

     xml.entry do

       url = url_for(item.event_url(:only_path => false, :protocol => protocol, :host => host))

       if @project == item.project

-        xml.title truncate_single_line_raw(item.event_title, 100)

+        xml.title truncate_single_line_raw(item.event_title, 300)

       else

-        xml.title truncate_single_line_raw("#{item.project} - #{item.event_title}", 100)

+        xml.title truncate_single_line_raw("#{item.project} - #{item.event_title}", 300)

       end

       xml.link "rel" => "alternate", "href" => url

       xml.id URL

#5 - 2021-01-02 13:04 - Go MAEDA

- Status changed from New to Confirmed

#6 - 2021-01-02 22:00 - Marius BĂLTEANU

Why truncate to 300 if the column length is 255?

Maybe it's better to not truncate anymore.

#7 - 2021-01-03 07:51 - Go MAEDA

Marius BALTEANU wrote:

Why truncate to 300 if the column length is 255?

 Although the maximum length of a subject is 255, a feed title includes additional information such as tracker name and project name.

Maybe it's better to not truncate anymore.

 I agree. The max length of a project name and a tracker name is 255 and 30, so I don't think there is any problem without truncate.

#8 - 2022-03-23 03:18 - Go MAEDA

- File 34025.diff added

- Target version set to Candidate for next major release

Attaching a patch.

#9 - 2022-03-23 14:45 - Holger Just

- Related to Patch #1356: In Activity views, changesets titles can be multiline while they should not added

#10 - 2022-03-23 14:45 - Holger Just

The truncate was initially introduced in #1356.

When changing this to not truncate titles, we should still try to avoiding multi-line event titles (e.g. by cutting of on the first newline or at least

transforming newlines to spaces as currently done in ApplicationHelper#truncate_single_line)

#11 - 2022-03-28 23:07 - Marius BĂLTEANU

- Target version changed from Candidate for next major release to 5.1.0

#12 - 2022-03-28 23:07 - Marius BĂLTEANU
https://www.redmine.org/issues/1356


- Target version changed from 5.1.0 to Candidate for next major release

#13 - 2024-02-04 06:05 - Go MAEDA

- Tracker changed from Defect to Feature

- Subject changed from Issue subject truncated to 100 chars in the list from Projects > View all issues > Atom to Raise the maximum length of the title

element in the Atom feed from 100 to 300 characters

- Target version changed from Candidate for next major release to 6.0.0

Holger Just wrote in #note-10:

The truncate was initially introduced in #1356.

When changing this to not truncate titles, we should still try to avoiding multi-line event titles (e.g. by cutting of on the first newline or at least

transforming newlines to spaces as currently done in ApplicationHelper#truncate_single_line)

 Thank you for the explanation.

I think my first patch in #note-4 is better than 34025.diff.

Setting the target version to 6.0.0.

#14 - 2024-02-07 05:27 - Go MAEDA

- Status changed from Confirmed to New

#15 - 2024-02-07 05:28 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22685.

Files

34025.diff 2.16 KB 2022-03-23 Go MAEDA
